# %%
import pandas as pd
import json

"""
Parses package.json in every node module package to get the version 
that is being used by each project for bundled packages.
"""

# %%
df = pd.read_csv('../data/dataset.csv')
repos = df['repo_path']

for repo in repos: 
    df_out = pd.DataFrame(columns = ['repo_name','dependency_name', 'version', 'is_bundled'])
    repo_name = str(repo).split('/')[-1]
    with open(repo + '/unpack.txt', 'r') as f:
        f.seek(0,0)
        dependencies = []
        dependency = ''
        for line in f.readlines():
            if 'node_modules' in line:
                if '\n' in line:
                    line = line.strip('\n')
                line = line[line.find('node_modules'):]
                if '@' in line:
                    line = line.split('/')[1] + '/' + line.split('/')[2]
                else:
                    line = line.split('/')[1]
                dependencies.append(line)
                dependencies = list(dict.fromkeys(dependencies))
        for dep in dependencies:
            try:
                with open(repo + '/node_modules/' + dep + '/package.json', 'r') as f2:
                    content = json.load(f2)
                    version = content['version']
                    df_out = df_out.append({'repo_name': repo_name,'dependency_name': dep, 'version': version, 'is_bundled': True}, ignore_index=True)
            except:
                print('Failed to open or parse file ' + repo + ' ' + dep)

    df_out.to_csv('../data/bundled_deps_version.csv', mode='a', header=False, index=False)

# %%
