# %%
import pandas as pd
import os
from glob import glob

"""
Gets map files path of each project.
"""
# %%
rows_list = []
repos = [s.rstrip('/') for s in glob('../../../../Volumes/WINDOWS/cloned_js_projects/' + '*/')]
for repo in repos:
    print('walking repo ' + repo)
    repo_name = repo.split('/')[6]
    map_files = []
    dic = {}
    for root, dirs, files in os.walk(repo):
        for file in files:
            if file.endswith('.map') and 'node_modules' not in root:
                map_files.append(os.path.join(root, file))
    dic = {'repo_name': repo_name, 'map_files': map_files}
    rows_list.append(dic)

df2 = pd.DataFrame(rows_list, columns=['repo_name', 'map_files'])
df3 = pd.read_csv('../data/repos.csv')
df2 = pd.merge(df3, df2, on='repo_name')
df2.to_csv('../data/dataset.csv', mode='w', index=False)

# %%
