import git
from glob import glob
import logging

"""
Script that we ended up not using because it generated too many build errors 
and we had to manually build every project. Most projects have different build configurations. 

This part could probably be automated better by parsing the package.json for build commands, 
but sometimes this was even not provided and we had to modify webpack configurations to 
generate the source maps. 
"""

logging.basicConfig(level=logging.INFO,
                    format='%(asctime)s - %(levelname)s - %(message)s',
                    filename='build_logs',
                    filemode='w')
console = logging.StreamHandler()
console.setLevel(logging.INFO)
formatter = logging.Formatter('%(asctime)s - %(levelname)s - %(message)s')
console.setFormatter(formatter)
logging.getLogger('').addHandler(console)

PATH = '../../../../../Volumes/WINDOWS/js_projects/'
subdirs = [s.rstrip('/') for s in glob(PATH + '*/')]
success_build = []
fail_build = []

for subdir in subdirs:
    repo = git.Repo(subdir)
    logging.info('Building project ' + subdir)
    try:
        repo.git.execute(['sudo', 'npm', 'install', '--unsafe-perm=true', '--allow-root'])
        logging.info('npm install successful for project ' + subdir)
        repo.git.execute(['sudo', 'npm', 'run-script', 'build', '--NODE_ENV="production"'])
        logging.info('Build successful for project ' + subdir)
        success_build.append(subdir)
    except:
        logging.info('Could not build project ' + subdir)
        fail_build.append(subdir)
        pass

logging.info('Done building projects')

logging.info('Failed builds: ' + str(success_build))
logging.info('Success builds: ' + str(fail_build))




