import pandas as pd
import os
from glob import glob
import csv

"""
The paths of this file are outdated and the files can be found in the history of our 
public repository. They ended up being removed from the source files since they were only
used to filter the final dataset. 

We are checking if the candidate projects are using a module bundler (webpack or rollup), 
and if upon building, source maps can be generated. In some cases, no matter the configurations, it was
impossible to generate source maps. 
"""

def phase1():
    df = pd.read_csv('data/selected_repos.csv')

    filtered_repos = df.loc[((df['webpack'] == True) | (df['rollup'] == True)) & (df['sideEffects_value'] == 'False')]

    filtered_repos.to_csv('data/filtered_repos.csv', mode='w', index=False)

def phase2():
    subdirs = [s.rstrip('/') for s in glob('../cloned_js_projects/' + '*/')]
    print(subdirs)
    rows = zip(subdirs)

    with open('data/2nd_filtered_repos.csv', 'w') as f:
        writer = csv.writer(f)
        for row in rows:
            writer.writerow(row)

def phase3():
    filtered_repos_3 = pd.read_csv('data/2nd_filtered_repos.csv')

    filtered_repos_3 = filtered_repos_3.loc[(filtered_repos_3['has_sourcemaps'] == True) & (filtered_repos_3['builds'] == True)]

    filtered_repos_3.to_csv('data/3rd_filtered_repos.csv', mode='w', index=False)

def phase4():
    rows_list = []
    repos = [s.rstrip('/') for s in glob('../../../../../Volumes/WINDOWS/cloned_js_projects/' + '*/')]
    for repo in repos:
        print('walking repo ' + repo)
        map_files = []
        dic = {}
        for root, dirs, files in os.walk(repo):
            for file in files:
                if file.endswith('.map') and 'node_modules' not in root:
                    map_files.append(os.path.join(root, file))
        dic = {'full_repo_name': repo, 'map_files': map_files}
        rows_list.append(dic)

    df2 = pd.DataFrame(rows_list, columns=['full_repo_name', 'map_files'])
    df3 = pd.read_csv('data/repos.csv')
    df2 = pd.merge(df3, df2, on='full_repo_name')
    df2.to_csv('data/dataset.csv', mode='w', index=False)

phase4()
def phase5():
    df1 = pd.read_csv('data2/filtered_repos.csv')
    df2 = pd.read_csv('data2/4th_filtered_repos2.csv')

    df1['name'] = df1['repo_name']
    df1['name'] = df1['repo_name'].apply(lambda x: x.split('/')[1])
    df1 = df1.rename(columns={'repo_name': 'fulL_repo_name'})

    df2['name'] = df2['repo_name']
    df2['name'] = df2['repo_name'].apply(lambda x: x.split('/')[6])
    df2 = df2.rename(columns={'repo_name': 'repo_path'})

    df3 = pd.merge(df1, df2, on='name')
    df3 = df3[['full_repo_name',
                'name',
                'repo_path',
                'stars',
                'created_at',
                'last_modified',
                'size',
                'has_dependabot',
                'webpack',
                'rollup',
                'sideEffects_value',
                'map_files'
    ]]
    df3.to_csv('data2/dataset2.csv', mode='w', index=False)
